#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

void kopiraj(char* s1, char* s2) {
    int i = 0;
    while (s2[i] != '\0') {
        s1[i] = s2[i];
        i++;
    }
    s1[i] = '\0';
}

void kopiraj_n(char* s1, char* s2, int n) {
    int i = 0;
    while (s2[i] != '\0' && i < n) {
        s1[i] = s2[i];
        i++;
    }
    s1[i] = '\0';
}

void nadovezi(char* s1, char* s2) {
    int i = 0;
    while (s1[i] != '\0') {
        i++;
    }
    int j = 0;
    while (s2[j] != '\0') {
        s1[i] = s2[j];
        i++;
        j++;
    }
    s1[i] = '\0';
}

void nadovezi_n(char* s1, char* s2, int n) {
    int i = 0;
    while (s1[i] != '\0') {
        i++;
    }
    int j = 0;
    while (s2[j] != '\0' && j < n) {
        s1[i] = s2[j];
        i++;
        j++;
    }
    s1[i] = '\0';
}

int uporedi(char* s1, char* s2) {
    int i = 0;
    while (s1[i] != '\0' && s2[i] != '\0') {
        if (s1[i] < s2[i]) {
            return -1;
        }
        else if (s1[i] > s2[i]) {
            return 1;
        }
        i++;
    }
    if (s1[i] == '\0' && s2[i] == '\0') {
        return 0;
    }
    else if (s1[i] == '\0') {
        return -1;
    }
    else {
        return 1;
    }
}

char* pronadji_c(char* s, char c) {
    int i = 0;
    while (s[i] != '\0') {
        if (s[i] == c) {
            return s + i;
        }
        i++;
    }
    return NULL;
}

int main()
{
    char color[] = "blue"; /// moze da se mijenja
    char *colorPtr = "blue"; /// ovakav string ne moze vise da se mijenja
    char colorList[] = {'b', 'l', 'u', 'e', '\0'};
    // \0 - terminacioni ili null karakter

    printf("%s\n", color);
    printf("%s\n", colorPtr);
    printf("%s\n", colorList);

    char s1[100];
    //scanf("%s", s1);
    //printf("%s\n", s1);
    //gets(s1);
    //puts(s1);

    char s2[100];
    sprintf(s2, "%s\t%s\n", color, colorPtr);
    puts(s2);

    int n = 2023;
    char s3[10];
    sprintf(s3, "%d", n);
    printf("%s\n", s3);

    // sscanf, atoi, atof ... - konverzije iz stringa u broj

    char s4[] = "25";
    sscanf(s4, "%d", &n);
    n = atoi(s4);
    printf("%d\n", n);

    char s5[100];
    char s6[100] = "programiranje";
    //strcpy(s5, s6);
    //kopiraj(s5, s6);
    //strncpy(s5, s6, 4);
    //kopiraj_n(s5, s6, 4);
    sprintf(s5, "%s", s6);
    printf("%s\n", s5);

    char s7[100] = "principi";
    char s8[100] = "programiranja";
    //strcat(s7, s8);
    //nadovezi(s7, s8);
    //strncat(s7, s8, 4);
    //nadovezi_n(s7, s8, 4);
    sprintf(s7, "%s%s", s7, s8);
    printf("%s\n", s7);

    char s9[10] = "abcd";
    char s10[10] = "abcd";
    printf("%d %d\n", strcmp(s9, s10), uporedi(s9, s10));

    char c = 'a';
    char* c_ptr = strchr(s6, c);
    printf("%p %p %p\n", s6, c_ptr, pronadji_c(s6, c));

    return 0;
}
